/**
* @author Vincent Pippan
* @version 1.0
* Projekt: Routenstatistik von Segelregatten
* Datei: InputStringParse.java
* Last Updated: 26. 5. 2002
* Beschreibung: Funktionen zum Aufteilen des Eingangsstrings aus der SourceDatei
*/

import java.io.*;
import java.lang.String.*;

public class InputStringParse
{
	public char nsvd, ewvd, lah, loh, ps;
	public String nsvm, ewvm, wd, wvm, lap, lop, hper;
	
	private int count=0;
	private int c;
	private char ch;
	private String nsbuffer, ewbuffer, labuffer, lobuffer, psbuffer;
	
	
	/** This function parses the string from each line from the source file
	* public void StringParse(Sting inline)
	@param inline Aus der Sourcedatei gelesener String
	*/
	public void StringParse(String inline)
	{
		try 
		{
			//Create a new StringReader
			StringReader fread = new StringReader(inline);
			
			//Reset all buffer strings and the counter
			count = 0;
			labuffer = "";
			lobuffer = "";
			psbuffer = "";
			ewbuffer = "";
			nsbuffer = "";
			wd = "";
			wvm = "";
			
			//Read each character from the input string
			while ((c = fread.read()) != -1) 
			{
				ch = (char) c;
				
				//Write the latitude data to the buffer
				if(count==6 && ch != '.') labuffer += ch;
				
				//Write the longititude data to the buffer
				if(count==7 && ch != '.') lobuffer += ch;
				
				//Write the positionstatus data to the buffer
				if(count==8 && ch != '.') psbuffer += ch;
				
				//Write the e/w velocity data to the buffer
				if(count==9 && ch != '.') ewbuffer += ch;
				
				//Write the n/s velocity data to the buffer
				if(count==10 && ch != '.') nsbuffer += ch;
				
				//Write the winddirection data to the buffer
				if(count==11 && ch != '.') wd += ch;
				
				//Write the windvelocity data to the buffer
				if(count==12 && ch != '.') wvm += ch;
				
				//Count the '.' to determine which data is currently read
				if(ch == '.') count = count + 1;
			}
			
			//Get the hemisphere from the buffer strings
			lah = (labuffer.substring(0,1)).charAt(0);
			loh = (lobuffer.substring(0,1)).charAt(0);
			
			//Get the position from the buffer strings
			lap = (labuffer.substring(1));
			lop = (labuffer.substring(1));
			
			//Convert to Stringbuffer to use the insert() method
			StringBuffer sblap = new StringBuffer(lap);
			StringBuffer sblop = new StringBuffer(lop);
			
			//Insert leading 0s if they are missing
			while(sblap.length() < 7)
			{
				sblap = sblap.insert(0,"0");
			}
			
			//Convert back to String
			lap = sblap.toString();
			
			//Insert leading 0s if they are missing
			while(sblop.length() < 8)
			{
				sblop = sblop.insert(0,"0");
			}
			
			//Convert back to String
			lop = sblop.toString();
			
			//Get the position status and the horizontal position error from the buffer string
			ps = (psbuffer.substring(0,1)).charAt(0);
			hper = (psbuffer.substring(1));
			
			//Get the velocity directions from the buffer strings
			ewvd = (ewbuffer.substring(0,1)).charAt(0);
			nsvd = (nsbuffer.substring(0,1)).charAt(0);
			
			//Get the velocity magnitude from the buffer strings
			ewvm = (ewbuffer.substring(1));
			nsvm = (nsbuffer.substring(1));
			
			//Close the StringReader
			fread.close();
		} 
		
		//Error Message
		catch (Exception e) 
		{
			System.out.println("Fehler beim Bearbeiten des InputStrings: "+e+"\n");
		}
	}
}