/**
* @author Vincent Pippan
* @version 1.0
* Projekt: Routenstatistik von Segelregatten
* Datei: TestGui.java
* Last Updated: 24. 5. 2002
* Beschreibung: Gui für Testzwecke zum Diplomarbeitsthema
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TestGui
extends JFrame
implements ActionListener
{
	private VectorFunctions vector = new VectorFunctions();
    private XYPosition position = new XYPosition();
	
	//Add the text fields
	JTextField yeartextfield = new JTextField(2);
	JTextField monthtextfield = new JTextField(2);
	JTextField daytextfield = new JTextField(2);
	JTextField hourtextfield = new JTextField(2);
	JTextField minutetextfield = new JTextField(2);
	JTextField secondtextfield = new JTextField(2);
	
	JTextField lahtextfield = new JTextField(1);
	JTextField laptextfield = new JTextField(8);
	JTextField lohtextfield = new JTextField(1);
	JTextField loptextfield = new JTextField(8);
	JTextField ewvdtextfield = new JTextField(1);
	JTextField ewvmtextfield = new JTextField(4);
	JTextField nsvdtextfield = new JTextField(1);
	JTextField nsvmtextfield = new JTextField(4);
	JTextField pstextfield = new JTextField(1);
	JTextField hpertextfield = new JTextField(3);
	JTextField wdtextfield = new JTextField(3);
	JTextField wvmtextfield = new JTextField(3);
	
	JTextField xtextfield = new JTextField(10);
	JTextField ytextfield = new JTextField(10);
	JTextField realwdtextfield = new JTextField(3);
	JTextField realwvmtextfield = new JTextField(3);
	JTextField relativwdtextfield = new JTextField(3);
	JTextField relativwvmtextfield = new JTextField(3);
	JTextField speedtextfield = new JTextField(3);
	JTextField coursetextfield = new JTextField(3);
	JTextField positionerrortextfield = new JTextField(3);
	JTextField gpsstatustextfield = new JTextField(3);
	JTextField timeindextextfield = new JTextField(3);
	
	JTextField laposreftextfield = new JTextField(10);
    JTextField loposreftextfield = new JTextField(10);
    JTextField masstabtextfield = new JTextField(10);
	
	public TestGui()
	{
		super("Test GUI zur GPS Datenauswertung");
	
		position.masstab = 10;
		position.laposref = "N1212345";
		position.loposref = "E12312345";
		position.XYInit();
		
		//Add the labels
		JLabel yearlabel = new JLabel("Year:",SwingConstants.LEFT);
		JLabel monthlabel = new JLabel("Month:",SwingConstants.LEFT);
		JLabel daylabel = new JLabel("Day:",SwingConstants.LEFT);
		JLabel hourlabel = new JLabel("Hour:",SwingConstants.LEFT);
		JLabel minutelabel = new JLabel("Minute:",SwingConstants.LEFT);
		JLabel secondlabel = new JLabel("Second:",SwingConstants.LEFT);
		
		JLabel lahlabel = new JLabel("Latitude Hemisphere:",SwingConstants.LEFT);
		JLabel laplabel = new JLabel("Latitude Position:",SwingConstants.LEFT);
		JLabel lohlabel = new JLabel("Longitude Hemisphere",SwingConstants.LEFT);
		JLabel loplabel = new JLabel("Longitude Position:",SwingConstants.LEFT);
		JLabel nsvdlabel = new JLabel("N / S Velocity Direction:",SwingConstants.LEFT);
		JLabel nsvmlabel = new JLabel("N / S Velocity Magnitude:",SwingConstants.LEFT);
		JLabel ewvdlabel = new JLabel("E / W Velocity Direction:",SwingConstants.LEFT);
		JLabel ewvmlabel = new JLabel("E / W Velocity Magnitude:",SwingConstants.LEFT);
		JLabel pslabel = new JLabel("Position Status:",SwingConstants.LEFT);
		JLabel hperlabel = new JLabel("Horinzontal Position Error:",SwingConstants.LEFT);
		JLabel wdlabel = new JLabel("Wind Direction:",SwingConstants.LEFT);
		JLabel wvmlabel = new JLabel("Wind Velocity Magnitude:",SwingConstants.LEFT);
		
		JLabel xlabel = new JLabel("X-Value:",SwingConstants.LEFT);
		JLabel ylabel = new JLabel("Y-Value:",SwingConstants.LEFT);
		JLabel realwdlabel = new JLabel("Real Wind Direction:",SwingConstants.LEFT);
		JLabel realwvmlabel = new JLabel("Real Wind Velocity Magnitude:",SwingConstants.LEFT);
		JLabel relativwdlabel = new JLabel("Relativ Wind Direction:",SwingConstants.LEFT);
		JLabel relativwvmlabel = new JLabel("Relativ Wind Velocity Magnitude:",SwingConstants.LEFT);
		JLabel speedlabel = new JLabel("Bootsgeschwindigkeit:");
		JLabel courselabel = new JLabel("Kurs:");
		JLabel positionerrorlabel = new JLabel("Position Error:");
		JLabel gpsstatuslabel = new JLabel("GPS Status:");
		JLabel timeindexlabel = new JLabel("Time Index",SwingConstants.LEFT);
		
		JLabel laposreflabel = new JLabel("Latitude Positions Nullreferenz (ddmmmmm):");
		JLabel loposreflabel = new JLabel("Longitude Positions Nullreferenz (dddmmmmm):");
		JLabel masstablabel = new JLabel("Anzahl der Pixel pro Meter auf der Computerkarte:");
		
		//Add the buttons
		JButton testbutton = new JButton("Test");
		JSlider timeslider = new JSlider(0, 0, 1000, 0);

		//Add timedataPanel
		JPanel timedataPanel = new JPanel();
		timedataPanel.setLayout (new GridLayout(2,2));
		timedataPanel.setBorder(BorderFactory.createEtchedBorder());
		
		//Add Objects to timedataPanel
		timedataPanel.add(yearlabel);
		timedataPanel.add(yeartextfield);
		timedataPanel.add(monthlabel);
		timedataPanel.add(monthtextfield);
		timedataPanel.add(daylabel);
		timedataPanel.add(daytextfield);
		timedataPanel.add(hourlabel);
		timedataPanel.add(hourtextfield);
		timedataPanel.add(minutelabel);
		timedataPanel.add(minutetextfield);
		timedataPanel.add(secondlabel);
		timedataPanel.add(secondtextfield);
		
		//Add positiondataPanel
		JPanel positiondataPanel = new JPanel();
		positiondataPanel.setLayout (new GridLayout(6,2));
		positiondataPanel.setBorder(BorderFactory.createEtchedBorder());
		
		//Add Objects to positiondataPanel
		positiondataPanel.add(lahlabel);
		positiondataPanel.add(lahtextfield);
		positiondataPanel.add(laplabel);
		positiondataPanel.add(laptextfield);
		positiondataPanel.add(lohlabel);
		positiondataPanel.add(lohtextfield);
		positiondataPanel.add(loplabel);
		positiondataPanel.add(loptextfield);
		positiondataPanel.add(nsvdlabel);
		positiondataPanel.add(nsvdtextfield);
		positiondataPanel.add(nsvmlabel);
		positiondataPanel.add(nsvmtextfield);
		positiondataPanel.add(ewvdlabel);
		positiondataPanel.add(ewvdtextfield);
		positiondataPanel.add(ewvmlabel);
		positiondataPanel.add(ewvmtextfield);
		positiondataPanel.add(pslabel);
		positiondataPanel.add(pstextfield);
		positiondataPanel.add(hperlabel);
		positiondataPanel.add(hpertextfield);
		positiondataPanel.add(wdlabel);
		positiondataPanel.add(wdtextfield);
		positiondataPanel.add(wvmlabel);
		positiondataPanel.add(wvmtextfield);
		
		//Add xydataPanel
		JPanel xydataPanel = new JPanel();
		xydataPanel.setLayout (new GridLayout(11,2));
		xydataPanel.setBorder(BorderFactory.createEtchedBorder());
		
		//Add Objects to xydataPanel
		xydataPanel.add(xlabel);
		xydataPanel.add(xtextfield);
		xydataPanel.add(ylabel);
		xydataPanel.add(ytextfield);
		xydataPanel.add(realwdlabel);
		xydataPanel.add(realwdtextfield);
		xydataPanel.add(realwvmlabel);
		xydataPanel.add(realwvmtextfield);
		xydataPanel.add(relativwdlabel);
		xydataPanel.add(relativwdtextfield);
		xydataPanel.add(relativwvmlabel);
		xydataPanel.add(relativwvmtextfield);
		xydataPanel.add(speedlabel);
		xydataPanel.add(speedtextfield);
		xydataPanel.add(courselabel);
		xydataPanel.add(coursetextfield);
		xydataPanel.add(positionerrorlabel);
		xydataPanel.add(positionerrortextfield);
		xydataPanel.add(gpsstatuslabel);
		xydataPanel.add(gpsstatustextfield);
		xydataPanel.add(timeindexlabel);
		xydataPanel.add(timeindextextfield);
		
		//Add buttonPanel
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout (new GridLayout(5,2));
		buttonPanel.setBorder(BorderFactory.createEtchedBorder());
		
		//Buttons hinzufügen
		testbutton.addActionListener(this);
		buttonPanel.add(testbutton);
		buttonPanel.add(timeslider); 
		timeslider.setMajorTickSpacing(100);
		timeslider.setMinorTickSpacing(10);
		timeslider.setPaintTicks(true);
		buttonPanel.add(laposreflabel);
		buttonPanel.add(laposreftextfield);
		buttonPanel.add(loposreflabel);
		buttonPanel.add(loposreftextfield);
		buttonPanel.add(masstablabel);
		buttonPanel.add(masstabtextfield);

		//Add the filePanel
		JPanel filePanel = new JPanel();
		filePanel.setLayout (new GridLayout(5,2));
		filePanel.setBorder(BorderFactory.createEtchedBorder());
		
		//Get the Content Pane
		getContentPane().setLayout(new GridLayout(5,1));
		getContentPane().add(timedataPanel);
		getContentPane().add(positiondataPanel);
		getContentPane().add(xydataPanel);
		getContentPane().add(buttonPanel);
		getContentPane().add(filePanel);
		
		//Windows-Listener
		addWindowListener(new WindowClosingAdapter(true));
	}
 
	//Action Listener
	public void actionPerformed(ActionEvent event)
	{
		String cmd = event.getActionCommand();
		try 
		{
		
			if (cmd.equals("Test")) 
			{
				//Read the wind data from the GUI
				vector.wd = wdtextfield.getText();
				vector.wvm = wvmtextfield.getText();
				vector.ewvm = ewvmtextfield.getText();
				vector.nsvm = nsvmtextfield.getText();
				vector.ewvd = (ewvdtextfield.getText()).charAt(0);
				vector.nsvd = (nsvdtextfield.getText()).charAt(0);
				
				//Read the position data from the GUI
				position.lah = (lahtextfield.getText()).charAt(0);
				position.loh = (lohtextfield.getText()).charAt(0);
				position.lop = loptextfield.getText();
				position.lap = laptextfield.getText();
				//position.laposref = laposreftextfield.getText();
				//position.loposref = loposreftextfield.getText();
				
				//Call the calculating functions
				vector.BoatData();
				vector.WindData();
				position.CalculateXY();
				
				//Put the wind data to the GUI
				realwdtextfield.setText("" + vector.realwd);
				realwvmtextfield.setText("" + vector.realwvm);
				speedtextfield.setText("" + vector.boatspeed);
				coursetextfield.setText("" + vector.boatdirection);
				relativwdtextfield.setText("" + vector.dwd);
				relativwvmtextfield.setText("" + vector.dwvm);
				
				//Put the position data to the GUI
				//gpsstatustextfield.setText("" + position.ps);
				//positionerrortextfield.setText(position.hper);
				xtextfield.setText("" + position.x);
				ytextfield.setText("" + position.y);
			} 
		} 
		
		catch (Exception e) 
		{
			System.err.println(e.toString());
		} 
	}
}
